
use std::collections::BTreeMap;
use std::sync::Arc;
use parking_lot::RwLock;
// use parking_lot::lock_api::RwLockReadGuard;

use serde::Deserialize;

// use app_env::appenv::AppEnv;
// use crate::utils::load_fs_content;
use crate::datacontext::{DataContext}; // , set_data_ctx};

// /// REQUEST
// #[derive(Clone, Debug, Serialize, Deserialize, Default)] // , SimpleObject)]
// pub struct Kloud<T> {
//   pub key: String,
//   pub data: T,
//   pub name: String, 
//   #[serde(default = "set_data_ctx")]
//   pub ctx: DataContext,
// }

// trait KloudStore<T> {
// 	fn into(s: Self) -> T;
// }

#[derive(Clone,Default)]
pub struct KloudStore<T> {
  pub entries: Arc<RwLock<BTreeMap<String,T>>>,
  pub coll_key: String,
  pub data_ctx: DataContext,
}
// impl<'_, T: ?Sized + AsRef<OsStr>> From<&'_ T> for KloudStore<T> {
// impl<T: Clone> KloudStore<T> { fn into(s: T) ->	T { s.clone() } }

impl<T> KloudStore<T> {
  pub fn new(data: BTreeMap<String,T>, coll_key: String, data_ctx: DataContext) -> Self {
    println!("Loading {} {} items",&coll_key,data.len());
    Self {
      entries: Arc::new(RwLock::new(data)),
      data_ctx,
      coll_key,
    }
  }
  pub fn set_context(&self, ctx: DataContext) -> Self {
    Self {
      entries: self.entries.clone(),
      data_ctx: ctx,
      coll_key: self.coll_key.to_owned(),
    }
  }
  // pub fn itms_from_data_file(&self, root: &str, target: &str, frmt: &str) {
  //   let content = load_fs_content(root, target, frmt);
  //   if content.is_empty() { return; }
  //   self.itms_from_content(content, frmt);
  // }
  
  // pub async fn map_data(&self, root: &str, target: &str, frmt: &str) -> String {
  //   let items = self.load_fs_data(root, target, frmt);
  //   let mut new_items: BTreeMap<String,T> = BTreeMap::new();
  //   for (k, v) in items {
  //     new_items.insert(k.to_owned(), T {
  //       key: k.to_owned(),
  //       data: v.data,
  //       name: v.name,
  //     });
  //   }
  //   match frmt {
  //     "yaml" => serde_yaml::to_string(&new_items).unwrap_or_else(|_| "".to_owned()),
  //     "json" => serde_json::to_string(&new_items).unwrap_or_else(|_| "".to_owned()),
  //     "toml" => toml::to_string(&new_items).unwrap_or_else(|_| "".to_owned()),
  //       _ => "".to_owned(),
  //   }
  // }
  // pub async fn get_data(&self, root: &str, target: &str, frmt: &str) -> BTreeMap<String,T> {
  //   self.load_fs_data(root, target, frmt)
  // }
}

#[derive(Debug, Deserialize)]
pub struct KloudQueryFilters {
  pub id: String,
  pub sort: String,
  pub start: i32,
  pub end: i32,
  // pub offset: Option<usize>,
  // pub limit: Option<usize>,
}

#[derive(Debug, Deserialize)]
pub struct KloudQueryDefsFilters {
  pub id: Option<String>,
}


#[derive(Debug, Deserialize)]
pub struct KloudQueryLangFilters {
  pub lang: Option<String>,
  pub section: Option<String>,
}

#[derive(Debug, Deserialize)]
pub struct KloudReqData {
  pub id: String,
  pub str_data: String,
}

#[derive(Debug, Deserialize)]
pub struct KloudQueryConfigFilters {
  pub cld: String,
  pub grp: String,
  pub name: String,
  pub tsksrvcs: String,
	pub srvrs: String,
}